#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdint.h>
#include <time.h>
#include <wiringPi.h>
#include <wiringPiI2C.h>

#define ADDRESS	0x1E
#define X_MSB_REGISTER	0x03
#define X_LSB_REGISTER	0x04
#define Y_MSB_REGISTER	0x05
#define Y_LSB_REGISTER	0x06
#define Z_MSB_REGISTER	0x07
#define Z_LSB_REGISTER	0x08

int main()
{
	int nCompass;
	if((nCompass = wiringPiI2CSetup(ADDRESS)) == -1)
	{
		printf("Unable to initialise I2C");
		return 1;
	}
	wiringPiI2CWriteReg8(nCompass, 0x02, 0x00);
		
	int i;
	uint8_t high[3], low[3];
	int result[3];
	while(1)
	{
		printf("nCompass = %d\r\n",nCompass);
		

		high[0]=wiringPiI2CReadReg8(nCompass,X_MSB_REGISTER);
		low[0]=wiringPiI2CReadReg8(nCompass,X_LSB_REGISTER);
		
		high[1]=wiringPiI2CReadReg8(nCompass,Y_MSB_REGISTER);
		low[1]=wiringPiI2CReadReg8(nCompass,Y_LSB_REGISTER);
		
		high[2]=wiringPiI2CReadReg8(nCompass,Z_MSB_REGISTER);
		low[2]=wiringPiI2CReadReg8(nCompass,Z_LSB_REGISTER);
		
		for(i = 0; i<3; i++)
		{
			result[i] = (high[i] <<8) | low[i];	
		}
		
		printf("x = %i, y = %i, z=%i\n" ,result[0],result[1],result[2]);
		delay(1000);
	}
	
	return 0;
	
}